AppTitle "Bump n' Jump"

Global res,res2,resx#,resy#

Cls
Print"Select Resolution:"
Print
Print"1 - 640x480x16"  
Print"2 - 640x480x32"
Print"3 - 800x600x16"
Print"4 - 800x600x32"
Print"5 - 1024x768x16"
Print"6 - 1024x768x32"

Repeat
	z=GetKey()
Until z>=Asc("1") And z<=Asc("6")
res=z-48
If res=1 Or res=2 Then resx=640:resy=480:res2=1
If res=3 Or res=4 Then resx=800:resy=600:res2=2
If res=5 Or res=6 Then resx=1024:resy=768:res2=3

If res=1 Or res=3 Or res=5 Then 
	Graphics3D resx,resy,16;,2
Else
	Graphics3D resx,resy,32;,2
EndIf
SeedRnd MilliSecs()

;Types
Type RoadPieceType
	Field a01,a02,a03,a04,a05,a06,a07,a08,a09  
	Field ls1,ls2
	Field t11,t12,t13,t14,t15,t16,t17,t18,t19
	Field t21,t22,t23,t24,t25,t26,t27,t28,t29
	Field BillBoard,BillBoardAd,GasStation
	Field typ
End Type

Type FlameType
	Field sprite,alpha#,faderate#,riserate#
End Type

Type SmokeType
	Field sprite,alpha#,faderate#,spinrate#,angle#,riserate#
End Type
	
Type FireSpotType
	Field x#,y#,z#
End Type

Type ParticleType
	Field sprite,mx#,my#,mz#,r#,g#,b#,dr#,dg#,db#,alpha#,faderate#
End Type

Type ScoringType
	Field sprite,life,alpha#
End Type

Type EnemyCarType
	Field body,w1,w2
	Field typ,speed#
End Type

Type DebrisType
	Field entity
End Type

;Meshes
Dim PlayerCarPart(7)     ;body=1 front=2 rear=3 cyls 1-4=4-7
Dim RoadPieceMesh(50)
Dim EnemyCarMesh(10)    
Global SkyDomeMesh,BillBoardAdMesh,WaterMesh,DebrisMesh

;Textures
Dim RoadPieceTex(4,50),BillBoardAdTex(15),WaterTex(4),SkyTex(4),EnemyCarTex(10)
Global PlayerCarBodyTex,CarWheelsTex,DebrisTex,GasStationTex

;Fonts
Dim Font(6)
Font(1)=LoadFont("Arial",30,True,False,False)
Font(2)=LoadFont("Arial",40,True,False,False)
Font(3)=LoadFont("Arial",50,True,False,False)
Font(4)=LoadFont("Arial",60,True,False,False)
Font(5)=LoadFont("Arial",80,True,False,False)
Font(6)=LoadFont("Arial",100,True,False,False)


;Sprites
Dim ScoringSprite(3)
Global CarShadowSprite=LoadSprite("Textures\Car - Shadow.png",2):SpriteViewMode CarShadowSprite,2:EntityAlpha CarShadowSprite,0.3:HideEntity CarShadowSprite
Global PlayerCarShadowSprite,FlameSprite,SmokeSprite,ParticleSprite
Global GameOverSprite

;Audio
Global IntroSong=LoadSound("Audio\Theme-Intro.mp3"):SoundVolume IntroSong,0.5
Global ThemeSong=LoadSound("Audio\Theme.mp3"):SoundVolume ThemeSong,0.4
Global EndLevelSong=LoadSound("Audio\Theme-end-of-level.mp3"):SoundVolume EndLevelSong,1
Global EngineSound=LoadSound("Audio\Engine.wav")
Global SmallExplosionSound=LoadSound("Audio\Explosion - Small.mp3")
Global LargeExplosionSound=LoadSound("Audio\Explosion.mp3")
Global JumpSound=LoadSound("Audio\Jump.wav")
Global JumpWarningSound=LoadSound("Audio\Jump Warning.wav")
Global BumpSound=LoadSound("Audio\Bump.mp3"):SoundVolume BumpSound,0.3
Global BonusCarSound=LoadSound("Audio\Bonus Car.mp3"):SoundVolume BonusCarSound,1
Global DumpTruckSound=LoadSound("Audio\Dump Truck.mp3"):SoundVolume DumpTruckSound,0.5
Global MusicChannel,EngineChannel,IntroPlayed,JumpChannel,JumpWarningChannel
LoopSound ThemeSong
LoopSound EngineSound
LoopSound JumpWarningSound
LoopSound JumpSound

;VARIABLES
;Road travel
Dim CloudMov#(2),CloudPos#(2),CylinderPos#(4),PlayerCarWheelPos#(2),RoadBlock(20,500),NumRoadBlocks(20)
Global Season,WaterPos#,WaterDir#,WaterSpeed#,Traveled#,CurRoadBlock,CurLevel,HitEnemyCar,Cheat,GameOver
;Player 
Dim CarPickPos(6)
Global Speed#,SpeedMove,PlayerCarX#,PlayerCarMovX#,PlayerCarMovY#,PlayerCarRotY#,PlayerCarMovRotY#,Lives,MusicOff
Global PlayerDeathTimer,VictoryTimer,CheckPoint,JumpTimer,JumpWarn,CanJump,PlayerCarRotX#,PlayerCarMovRotX#,Score,Blink,NextBonusCar,CarsCrashed
Global Frametimer=CreateTimer(60)
;Enemies
Dim EnemyEnt(10),EnemyExist(10),EnemySpeed#(10),EnemyMX#(10),EnemyMZ#(10),EnemyWeight#(10),EnemyType(10),EnemyMY#(10),EnemyFalling(10),EnemyShadow(10),EnemyBumped(10)
Dim EnemySpeedMaint(10),EnemyWeaveDir(10),EnemyWeaveCount(10),EnemyDumpTimer(10)

Global Camera=CreateCamera()
Global light=CreateLight():RotateEntity Light,90,0,0

InitializeVariables
LoadGameMeshesAndTextures
TitleScreen
NextLevel
ChangeSeason(Season)
SetUpStartRoad
MusicChannel=PlaySound(IntroSong)
EngineChannel=PlaySound(EngineSound):ChannelVolume EngineChannel,0.15


While Not KeyDown(1)
	kk=GetKey()
	
	If kk=Asc("M") Or kk=Asc("m") Then
		If MusicOff=False Then MusicOff=True Else MusicOff=False
		If MusicOff=True Then ChannelVolume MusicChannel,0
		If MusicOff=False Then ChannelVolume MusicChannel,0.4
	EndIf
	
	If kk=Asc("p") Or kk=Asc("P") Then
		Repeat
			kk=GetKey()
		Until kk=Asc("p") Or kk=Asc("P")
	EndIf

	If kk=Asc("c") Or kk=Asc("C") Then
		If Cheat=False Then Cheat=True Else Cheat=False
	EndIf

	If PlayerDeathTimer=0 And GameOver=False And CurRoadBlock-7<NumRoadBlocks(CurLevel) Then
		If SpeedMove=0 Then
			If KeyDown(200) And SpeedMov=0 Then Speed=Speed+1
			If KeyDown(208) And SpeedMov=0 Then Speed=Speed-1
			If KeyDown(205) Then PlayerCarMovX=PlayerCarMovX+0.01:PlayerCarMovRotY=PlayerCarMovRotY-0.3
			If KeyDown(203) Then PlayerCarMovX=PlayerCarMovX-0.01:PlayerCarMovRotY=PlayerCarMovRotY+0.3
			If kk=32 Then 
				If JumpTimer=0 And Speed>=100 And CanJump=True Then JumpTimer=1
			EndIf
		EndIf
	
		;If kk=Asc("1") Then AddEnemyCar(1,Rnd(-4,4),60)
		;If kk=Asc("2") Then AddEnemyCar(2,Rnd(-4,4),60)
		;If kk=Asc("3") Then AddEnemyCar(3,Rnd(-4,4),60)
		;If kk=Asc("4") Then AddEnemyCar(4,Rnd(-4,4),60)
		;If kk=Asc("5") Then AddEnemyCar(5,Rnd(-4,4),90)
		;If kk=Asc("6") Then AddEnemyCar(6,Rnd(-4,4),60)
		;If kk=Asc("7") Then AddEnemyCar(7,Rnd(-4,4),60)
		;If kk=Asc("8") Then AddEnemyCar(8,Rnd(-4,4),60)
		;If kk=Asc("9") Then AddEnemyCar(9,Rnd(-4,4),60)
		;If kk=Asc("0") Then AddEnemyCar(10,Rnd(-4,4),60)

		;If kk=Asc("d") Then AddDebris(Rnd(-4,4),100)
		
		If (Not KeyDown(205)) And (Not KeyDown(203)) Then 
			PlayerCarMovX=PlayerCarMovX*0.95
			PlayerCarMovRotY=0
			PlayerCarRotY=PlayerCarRotY*0.90
		EndIf

		If SpeedMove<>0 Then
			If SpeedMove>0 Then Speed=Speed+2:SpeedMove=SpeedMove-1
			If SpeedMove<0 Then Speed=Speed-2:SpeedMove=SpeedMove+1
		EndIf
		If Speed>220 Then Speed=220
		If Speed<20 Then Speed=20
	EndIf

	;Game Over screen
	If GameOver=False Then HideEntity GameOverSprite
	If GameOver=True Then
		ShowEntity GameOverSprite
		StopChannel MusicChannel
		StopChannel EngineChannel
		Speed=0
		If kk=32 Then 
			Traveled=0:Speed=20:WaterPos=0:WaterDir=0:WaterSpeed=Rnd(-0.001,0.001):Season=1:CurLevel=0:JumpTimer=0:SpeedMove=0:Score=0:Blink=0:Lives=5
			IntroPlayed=False:GameOver=False:PlayerDeathTimer=0:NextBonusCar=10000
			NextLevel:PlaceNewPlayerCar
			If MusicOff=False Then MusicChannel=PlaySound(IntroSong)
		EndIf		
		
	EndIf
	

	Traveled=Traveled+(Speed/220)
	If PlayerDeathTimer=0 And VictoryTimer=0 Then UpdatePlayerCar
	UpdateEnemyCars
	UpdateDebris
	UpdateFires
	UpdateParticles
	UpdateScoringSprites
	If VictoryTimer=0 Then UpdateRoadTravel

	If PlayerDeathTimer<>0 Then
		PlayerDeathTimer=PlayerDeathTimer+1
		If PlayerDeathTimer=100 Then 
			PlaceNewPlayerCar
			If Cheat=False Then Lives=Lives-1
				For a=1 To 10
					If EnemyExist(a)=True Then
						FreeEntity EnemyEnt(a)
						EnemyExist(a)=False
					EndIf
				Next
			If Lives<=0 Then 
				GameOver=True
			EndIf

		EndIf
	EndIf
	
	
	;Music
	If VictoryTimer=0 And ChannelPlaying(MusicChannel)=False Then 
		MusicChannel=PlaySound(ThemeSong)
		If GameOver=True Then StopChannel MusicChannel
		If MusicOff=True Then ChannelVolume MusicChannel,0
	EndIf
	
	WaitTimer(FrameTimer)
	UpdateWorld
	RenderWorld

	If VictoryTimer>0 Then
		Speed=0
		VictoryTimer=VictoryTimer+1
		UpdateVictoryScreen
		If VictoryTimer>500 Then NextLevel:PlaceNewPlayerCar
	EndIf

	UpdateHUD
	Flip
Wend

Function InitializeVariables()
	Traveled=0:Speed=20:WaterPos=0:WaterDir=0:WaterSpeed=Rnd(-0.001,0.001):Season=1:CurLevel=0:JumpTimer=0:SpeedMove=0:Score=0:Blink=0:Lives=5
	IntroPlayed=False:MusicOff=False:GameOver=False:NextBonusCar=10000:CarsCrashed=0:Cheat=False
	PlayerDeathTimer=0
	For a=1 To 4:CylinderPos(a)=(a-1)*90:Next
	For a=1 To 2:PlayerCarWheelPos(a)=(a-1)*180:Next
	For a=1 To 20
		FileOpen=OpenFile("Levels\Road."+a)
		NumRoadBlocks(a)=ReadShort(FileOpen)
		For b=1 To NumRoadBlocks(a)
			RoadBlock(a,b)=ReadByte(FileOpen)
			
			;RoadBlock(a,b)=1
			
		Next		
		CloseFile(FileOpen)
	Next
	For a=1 To 10:EnemyExist(a)=False:Next
	NumRoadBlocks(0)=500
	For a=1 To 500:RoadBlock(0,a)=1:Next
End Function

Function LoadGameMeshesAndTextures()
	GameOverSprite=LoadSprite("Textures\Game Over.png"):HideEntity GameOverSprite
	FlameSprite=LoadSprite("Textures\Fire.png",2):HideEntity FlameSprite
	SmokeSprite=LoadSprite("Textures\Smoke.png",2):HideEntity SmokeSprite
	ParticleSprite=LoadSprite("Textures\Particle.png",2):HideEntity ParticleSprite
	ScoringSprite(1)=LoadSprite("textures\200.png",2):ScoringSprite(2)=LoadSprite("textures\300.png",2):ScoringSprite(3)=LoadSprite("textures\400.png",2):
	ScoringSprite(4)=LoadSprite("textures\500.png",2):ScoringSprite(5)=LoadSprite("textures\600.png",2):ScoringSprite(6)=LoadSprite("textures\1000.png",2):
	For a=1 To 6:EntityOrder ScoringSprite(a),-1:HideEntity ScoringSprite(a):Next

	CarWheelsTex=LoadTexture("Textures\Car - Wheels.jpg")
	PlayerCarBodyTex=LoadTexture("Textures\Car - Player.jpg")
	For a=1 To 7
		If a=2 Or a=3 Then
			PlayerCarPart(a)=LoadMesh("Models\Car - Player - Wheels.b3d")
		Else
			PlayerCarPart(a)=LoadMesh("Models\Car - player - "+a+".b3d")
		EndIf
		If a>1 Then EntityParent PlayerCarPart(a),PlayerCarPart(1)
		If a=1 Then EntityTexture PlayerCarPart(a),PlayerCarBodyTex
	Next
	PositionEntity PlayerCarPart(2),0,-0.5,2
	PositionEntity PlayerCarPart(3),0,-0.5,-2
	;EntityPickMode PlayerCarPart(1),2
	EntityBox PlayerCarPart(1),-0.2,-0.2,-0.4,0.4,0.4,1
	EntityRadius PlayerCarPart(1),0.4
	
	ScaleEntity PlayerCarPart(1),0.15,0.15,0.15
	RotateEntity PlayerCarPart(1),0,180,0
	EntityTexture PlayerCarPart(2),CarWheelsTex:EntityTexture PlayerCarPart(3),CarWheelsTex

	;Enemy car meshes
	EnemyCarMesh(1)=LoadAnimMesh("Models\Enemy - Tractor.b3d")
	EnemyCarMesh(2)=LoadAnimMesh("Models\Enemy - Cycle.b3d")
	EnemyCarMesh(3)=LoadAnimMesh("Models\Enemy - Skull.b3d")
	EnemyCarMesh(4)=LoadAnimMesh("Models\Enemy - Race and Brown.b3d")  ; Race
	EnemyCarMesh(5)=LoadAnimMesh("Models\Enemy - Dump Truck.b3d")
	EnemyCarMesh(6)=LoadAnimMesh("Models\Enemy - White.b3d")
	EnemyCarMesh(7)=LoadAnimMesh("Models\Enemy - Yellow Truck.b3d")
	EnemyCarMesh(8)=LoadAnimMesh("Models\Enemy - Green.b3d")
	EnemyCarMesh(9)=LoadAnimMesh("Models\Enemy - Blue.b3d")
	EnemyCarMesh(10)=LoadAnimMesh("Models\Enemy - Race and Brown.b3d")  ;Brown
	
	ExtractAnimSeq EnemyCarMesh(1),1,5
	ExtractAnimSeq EnemyCarMesh(2),1,5
	ExtractAnimSeq EnemyCarMesh(3),1,9
	ExtractAnimSeq EnemyCarMesh(4),1,9
	
	ExtractAnimSeq EnemyCarMesh(5),1,5
	ExtractAnimSeq EnemyCarMesh(5),6,18
	ExtractAnimSeq EnemyCarMesh(5),19,23
		
	ExtractAnimSeq EnemyCarMesh(6),1,9
	ExtractAnimSeq EnemyCarMesh(7),1,5
	ExtractAnimSeq EnemyCarMesh(8),1,9
	ExtractAnimSeq EnemyCarMesh(9),1,9
	ExtractAnimSeq EnemyCarMesh(10),1,9
	
	
	EnemyCarTex(1)=LoadTexture("Textures\Enemy - Tractor.jpg")
	EnemyCarTex(2)=LoadTexture("Textures\Enemy - Cycle.jpg")
	EnemyCarTex(3)=LoadTexture("Textures\Enemy - Skull.jpg")
	EnemyCarTex(4)=LoadTexture("Textures\Enemy - Race.jpg")
	EnemyCarTex(5)=LoadTexture("Textures\Enemy - Dump Truck.jpg")
	EnemyCarTex(6)=LoadTexture("Textures\Enemy - White.jpg")
	EnemyCarTex(7)=LoadTexture("Textures\Enemy - Yellow Truck.jpg")
	EnemyCarTex(8)=LoadTexture("Textures\Enemy - Green.jpg")
	EnemyCarTex(9)=LoadTexture("Textures\Enemy - Blue.jpg")
	EnemyCarTex(10)=LoadTexture("Textures\Enemy - Brown.jpg")

	For a=1 To 10
		ScaleEntity EnemyCarMesh(a),0.2,0.2,0.2
		HideEntity EnemyCarMesh(a)
		EntityTexture EnemyCarMesh(a),EnemyCarTex(a)
	Next
	ScaleEntity EnemyCarMesh(5),0.33,0.33,0.33
	ScaleEntity EnemyCarMesh(2),0.5,0.2,0.2
	ScaleEntity EnemyCarMesh(4),0.15,0.15,0.15
	ScaleEntity EnemyCarMesh(6),0.15,0.15,0.15
	ScaleEntity EnemyCarMesh(10),0.16,0.16,0.16

	DebrisMesh=LoadMesh("Models\Debris.b3d")
	DebrisTex=LoadTexture("Textures\Debris.jpg")
	ScaleEntity DebrisMesh,0.3,0.3,0.3
	EntityTexture DebrisMesh,DebrisTex:HideEntity DebrisMesh
	EntityPickMode DebrisMesh,2

	SkyDomeMesh=CreateSphere(24):FlipMesh(SkyDomeMesh):ScaleEntity SkyDomeMesh,300,30,300:RotateEntity SkyDomeMesh,0,180,0
	EntityFX SkyDomeMesh,1
	
	WaterMesh=CreateCube():ScaleEntity WaterMesh,100,1,100:PositionEntity WaterMesh,0,-5.4,0:EntityPickMode WaterMesh,2
	WaterTex(1)=LoadTexture("Textures\Water - Spring.jpg")
	WaterTex(2)=LoadTexture("Textures\Water - Summer.jpg")
	WaterTex(3)=LoadTexture("Textures\Water - Fall.jpg")
	WaterTex(4)=LoadTexture("Textures\Water - Winter.jpg")
	For a=1 To 4:ScaleTexture WaterTex(a),0.05,0.05:Next
	SkyTex(1)=LoadTexture("Textures\Sky - Spring.jpg")
	SkyTex(2)=LoadTexture("Textures\Sky - Summer.jpg")
	SkyTex(3)=LoadTexture("Textures\Sky - Fall.jpg")
	SkyTex(4)=LoadTexture("Textures\Sky - Winter.jpg")
	For a=1 To 4:ScaleTexture WaterTex(a),0.2,0.2:ScaleTexture SkyTex(a),2,2:Next
		
	BillBoardAdMesh=LoadMesh("Models\BillBoard Ad.b3d"):EntityPickMode BillBoardAdMesh,2:HideEntity BillBoardAdMesh
	
	RoadPieceMesh(1)=LoadMesh("Models\Flat Road.b3d")
	RoadPieceTex(1,1)=LoadTexture("Textures\Flat Road - Spring.jpg")
	RoadPieceTex(2,1)=LoadTexture("Textures\Flat Road - Spring.jpg")
	RoadPieceTex(3,1)=LoadTexture("Textures\Flat Road - Fall.jpg")
	RoadPieceTex(4,1)=LoadTexture("Textures\Flat Road - Winter.jpg")
	RoadPieceMesh(2)=LoadMesh("Models\Fence Whole.b3d")
	RoadPieceTex(1,2)=LoadTexture("Textures\Fence Whole - Spring.jpg")
	RoadPieceTex(2,2)=LoadTexture("Textures\Fence Whole - Spring.jpg")
	RoadPieceTex(3,2)=LoadTexture("Textures\Fence Whole - Spring.jpg")
	RoadPieceTex(4,2)=LoadTexture("Textures\Fence Whole - Winter.jpg")
	RoadPieceMesh(3)=LoadMesh("Models\Rough Start Right.b3d")
	RoadPieceTex(1,3)=LoadTexture("Textures\Rough Start Right - Spring.jpg")
	RoadPieceTex(2,3)=LoadTexture("Textures\Rough Start Right - Summer.jpg")
	RoadPieceTex(3,3)=LoadTexture("Textures\Roughs - Fall.jpg")
	RoadPieceTex(4,3)=LoadTexture("Textures\Rough Start Right - Winter.jpg")
	RoadPieceMesh(4)=LoadMesh("Models\Rough Right.b3d")
	RoadPieceTex(1,4)=LoadTexture("Textures\Rough Right - Spring.jpg")
	RoadPieceTex(2,4)=LoadTexture("Textures\Rough Right - Summer.jpg")
	RoadPieceTex(3,4)=LoadTexture("Textures\Roughs - Fall.jpg")
	RoadPieceTex(4,4)=LoadTexture("Textures\Rough Right - Winter.jpg")
	RoadPieceMesh(5)=LoadMesh("Models\Rough End Right.b3d")
	RoadPieceTex(1,5)=LoadTexture("Textures\Rough End Right - Spring.jpg")
	RoadPieceTex(2,5)=LoadTexture("Textures\Rough End Right - Summer.jpg")
	RoadPieceTex(3,5)=LoadTexture("Textures\Roughs - Fall.jpg")
	RoadPieceTex(4,5)=LoadTexture("Textures\Rough End Right - Winter.jpg")
	RoadPieceMesh(6)=LoadMesh("Models\Rough Start Left.b3d")
	RoadPieceTex(1,6)=LoadTexture("Textures\Rough Start Left - Spring.jpg")
	RoadPieceTex(2,6)=LoadTexture("Textures\Rough Start Left - Summer.jpg")
	RoadPieceTex(3,6)=LoadTexture("Textures\Roughs - Fall.jpg")
	RoadPieceTex(4,6)=LoadTexture("Textures\Rough Start Left - Winter.jpg")
	RoadPieceMesh(7)=LoadMesh("Models\Rough Left.b3d")
	RoadPieceTex(1,7)=LoadTexture("Textures\Rough Left - Spring.jpg")
	RoadPieceTex(2,7)=LoadTexture("Textures\Rough Left - Summer.jpg")
	RoadPieceTex(3,7)=LoadTexture("Textures\Roughs - Fall.jpg")
	RoadPieceTex(4,7)=LoadTexture("Textures\Rough Left - Winter.jpg")
	RoadPieceMesh(8)=LoadMesh("Models\Rough End Left.b3d")
	RoadPieceTex(1,8)=LoadTexture("Textures\Rough End Left - Spring.jpg")
	RoadPieceTex(2,8)=LoadTexture("Textures\Rough End Left - Summer.jpg")
	RoadPieceTex(3,8)=LoadTexture("Textures\Roughs - Fall.jpg")
	RoadPieceTex(4,8)=LoadTexture("Textures\Rough End Left - Winter.jpg")
	RoadPieceMesh(9)=LoadMesh("Models\Fence Half.b3d")
	RoadPieceTex(1,9)=LoadTexture("Textures\Fence Half - Spring.jpg")
	RoadPieceTex(2,9)=LoadTexture("Textures\Fence Half - Spring.jpg")
	RoadPieceTex(3,9)=LoadTexture("Textures\Fence Half - Spring.jpg")
	RoadPieceTex(4,9)=LoadTexture("Textures\Fence Half - Winter.jpg")
	RoadPieceMesh(10)=LoadMesh("Models\Fence V.b3d")
	RoadPieceTex(1,10)=LoadTexture("Textures\Fence V - Spring.jpg")
	RoadPieceTex(2,10)=LoadTexture("Textures\Fence V - Spring.jpg")
	RoadPieceTex(3,10)=LoadTexture("Textures\Fence V - Spring.jpg")
	RoadPieceTex(4,10)=LoadTexture("Textures\Fence V - Winter.jpg")
	RoadPieceMesh(11)=LoadMesh("Models\Shrubbery V.b3d")
	RoadPieceTex(1,11)=LoadTexture("Textures\Shrubbery V - Spring.jpg")
	RoadPieceTex(2,11)=LoadTexture("Textures\Shrubbery V - Summer.jpg")
	RoadPieceTex(3,11)=LoadTexture("Textures\Roughs - Fall.jpg")
	RoadPieceTex(4,11)=LoadTexture("Textures\Shrubbery V - Winter.jpg")
	RoadPieceMesh(12)=LoadMesh("Models\Shrubbery Central.b3d")
	RoadPieceTex(1,12)=LoadTexture("Textures\Shrubbery Central - Spring.jpg")
	RoadPieceTex(2,12)=LoadTexture("Textures\Shrubbery Central - Summer.jpg")
	RoadPieceTex(3,12)=LoadTexture("Textures\Roughs - Fall.jpg")
	RoadPieceTex(4,12)=LoadTexture("Textures\Shrubbery Central - Winter.jpg")
	RoadPieceMesh(13)=LoadMesh("Models\Rocks.b3d")
	RoadPieceTex(1,13)=LoadTexture("Textures\Rocks - Spring.jpg")
	RoadPieceTex(2,13)=LoadTexture("Textures\Rocks - Spring.jpg")
	RoadPieceTex(3,13)=LoadTexture("Textures\Rocks - Spring.jpg")
	RoadPieceTex(4,13)=LoadTexture("Textures\Rocks - Winter.jpg")
	RoadPieceMesh(14)=LoadMesh("Models\Causeway.b3d")
	RoadPieceTex(1,14)=LoadTexture("Textures\Causeway - Spring.jpg")
	RoadPieceTex(2,14)=LoadTexture("Textures\Causeway - Spring.jpg")
	RoadPieceTex(3,14)=LoadTexture("Textures\Causeway - Spring.jpg")
	RoadPieceTex(4,14)=LoadTexture("Textures\Causeway - Winter.jpg")
	RoadPieceMesh(15)=LoadMesh("Models\Tree.b3d"):EntityFX RoadPieceMesh(15),16  ;Double sided
	RoadPieceTex(1,15)=LoadTexture("Textures\Tree - Spring.png",3)
	RoadPieceTex(2,15)=LoadTexture("Textures\Tree - Summer.png",3)
	RoadPieceTex(3,15)=LoadTexture("Textures\Tree - Fall.png",3)
	RoadPieceTex(4,15)=LoadTexture("Textures\Tree - Winter.png",3)
	RoadPieceMesh(16)=LoadMesh("Models\Island Small.b3d")
	RoadPieceTex(1,16)=LoadTexture("Textures\Island - Spring.jpg")
	RoadPieceTex(2,16)=LoadTexture("Textures\Island - Spring.jpg")
	RoadPieceTex(3,16)=LoadTexture("Textures\Island - Spring.jpg")
	RoadPieceTex(4,16)=LoadTexture("Textures\Island - Winter.jpg")
	RoadPieceMesh(17)=LoadMesh("Models\Island Large.b3d")
	RoadPieceTex(1,17)=LoadTexture("Textures\Island - Spring.jpg")
	RoadPieceTex(2,17)=LoadTexture("Textures\Island - Spring.jpg")
	RoadPieceTex(3,17)=LoadTexture("Textures\Island - Spring.jpg")
	RoadPieceTex(4,17)=LoadTexture("Textures\Island - Winter.jpg")
	RoadPieceMesh(18)=LoadMesh("Models\Land Slice.b3d")
	RoadPieceTex(1,18)=LoadTexture("Textures\Land Slice - Spring.jpg")
	RoadPieceTex(2,18)=LoadTexture("Textures\Land Slice - Summer.jpg")
	RoadPieceTex(3,18)=LoadTexture("Textures\Land Slice - Fall.jpg")
	RoadPieceTex(4,18)=LoadTexture("Textures\Land Slice - Winter.jpg")
	RoadPieceMesh(19)=LoadMesh("Models\BillBoard.b3d")
	RoadPieceTex(1,19)=LoadTexture("Textures\BillBoard - Spring.png",3)
	RoadPieceTex(2,19)=LoadTexture("Textures\BillBoard - Spring.png",3)
	RoadPieceTex(3,19)=LoadTexture("Textures\BillBoard - Spring.png",3)
	RoadPieceTex(4,19)=LoadTexture("Textures\BillBoard - Winter.png ",3)
	RoadPieceMesh(20)=LoadMesh("Models\Gas Station.b3d")
	RoadPieceTex(1,20)=LoadTexture("Textures\Gas Station - Spring.jpg")
	RoadPieceTex(2,20)=LoadTexture("Textures\Gas Station - Spring.jpg")
	RoadPieceTex(3,20)=LoadTexture("Textures\Gas Station - Spring.jpg")
	RoadPieceTex(4,20)=LoadTexture("Textures\Gas Station - Winter.jpg")
	For a=1 To 15:BillBoardAdTex(a)=LoadTexture("Textures\Ad-"+a+".jpg"):Next
	For a=1 To 20:EntityFX RoadPieceMesh(a),16:HideEntity RoadPieceMesh(a)
		If a<>15 Then EntityPickMode RoadPieceMesh(a),2
	Next
End Function

Function ChangeSeason(s)
	For a=1 To 20:EntityTexture RoadPieceMesh(a),RoadPieceTex(s,a):Next
	EntityTexture SkyDomeMesh,SkyTex(s)
	EntityTexture WaterMesh,WaterTex(s)
End Function

Function NextLevel()
	CarsCrashed=0
	CurLevel=CurLevel+1
	If CurLevel>20 Then CurLevel=1
	CheckPoint=1:CurRoadBlock=1:VictoryTimer=0
	Season=Season+1
	If CurLevel=1 Or CurLevel=2 Then Season=1
	If Season>4 Then Season=1
	ChangeSeason(Season)
	For RoadPiece.RoadPieceType=Each RoadPieceType
		FreeEntity RoadPiece\a01
		Delete RoadPiece
	Next
End Function

Function TitleScreen()
	ChangeSeason(1):ScaleEntity SkyDomeMesh,600,60,600
	For a=1 To 20:AddNewRoadPiece(1,0,0,(a-1)*20):Next
	PlayerCarShadowSprite=CopyEntity(CarShadowSprite):RotateEntity PlayerCarShadowSprite,90,0,0:ScaleSprite PlayerCarShadowSprite,0.8,0.65
	PositionEntity PlayerCarPart(1),0,0.23,200:PositionEntity PlayerCarShadowSprite,0,0.001,200
	PositionEntity Camera,0,2.5,196
	TitleSprite=LoadSprite("Textures\Title.png",2)
	PositionEntity TitleSprite,0,2.5,198:EntityParent TitleSprite,Camera:EntityOrder TitleSprite,-1:ScaleSprite TitleSprite,1.5,1.5
	GameOverSprite=LoadSprite("Textures\Game Over.png",2)
	PositionEntity GameOverSprite,0,2.5,198:EntityParent GameOverSprite,Camera:EntityOrder GameOverSprite,-1:ScaleSprite GameOverSprite,1.5,1.5
	HideEntity GameOverSprite
	CameraPivot=CreatePivot():PositionEntity CameraPivot,0,0.23,200:EntityParent Camera,CameraPivot
	Traveled=0
	For a=1 To 2
		CloudMov(a)=Rnd(-0.0003,0.0003)
		CloudPos(a)=0
	Next
	For a=1 To 2
		CloudPos(a)=CloudPos(a)+CloudMov(a)
		If CloudPos(a)>1 Then CloudPos(a)=CloudPos(a)-1
		If CloudPos(a)<-1 Then CloudPos(a)=CloudPos(a)+1
	Next
	PositionTexture SkyTex(Season),CloudPos(1),CloudPos(2)

	CameraDist=0

	While Not KeyDown(57)
	
		Traveled=Traveled+1
		For RoadPiece.RoadPieceType=Each RoadPieceType
			TranslateEntity Roadpiece\a01,0,0,-1
			If Traveled>=20 Then AddNewRoadPiece(1,0,0,380):Traveled=0
			If EntityZ(RoadPiece\a01)<0 Then FreeEntity RoadPiece\a01:Delete RoadPiece
		Next
		
		For a=1 To 4
			CylinderPos(a)=CylinderPos(a)+(220/3)
			If CylinderPos(a)>360 Then CylinderPos(a)=CylinderPos(a)-360
			PositionEntity PlayerCarPart(a+3),0,Sin(CylinderPos(a))*0.10,0
		Next
		For a=1 To 2
			PlayerCarWheelPos(a)=PlayerCarWheelPos(a)+(220/5)
			If PlayerCarWheelPos(a)>360 Then PlayerCarWheelPos(a)=PlayerCarWheelPos(a)-360
			If a=1 Then z=2 Else z=-2
			PositionEntity PlayerCarPart(a+1),Sin(PlayerCarWheelPos(a))*0.15,-0.5,z
			For b=2 To 3
				TurnEntity PlayerCarPart(b),-220/10,0,0
			Next
		Next
	
		TurnEntity CameraPivot,0,1,0
		CameraDist=CameraDist+1
		If CameraDist>359 Then CameraDist=CameraDist-360
		MoveEntity Camera,0,0,(Sin(CameraDist)/50)
		
		PointEntity Camera,CameraPivot
		UpdateWorld
		RenderWorld
		Flip
	Wend
	EntityParent Camera,0
	FreeEntity CameraPivot
	For RoadPiece.RoadPieceType=Each RoadPieceType
		FreeEntity RoadPiece\a01:Delete RoadPiece
	Next	
	Traveled=0:FreeEntity TitleSprite
End Function

Function GameOverScreen()


End Function

Function PlaceNewPlayerCar()
	For Debris.DebrisType=Each DebrisType
		FreeEntity Debris\entity:Delete Debris
	Next
	PlayerDeathTimer=0:JumpTimer=0:SpeedMove=0
	PositionEntity PlayerCarPart(1),0,1,0
	Speed=20:PlayerCarX=0:PlayerCarMovX=0:PlayerCarMovRotY=0:PlayerCarRotY=0:PlayerCarRotX=0:PlayerCarMovY=0
	ShowEntity PlayerCarPart(1):ShowEntity PlayerCarShadowSprite
	For RoadPiece.RoadPieceType=Each RoadPieceType
		FreeEntity RoadPiece\a01:Delete RoadPiece	
	Next
	For a=CheckPoint To Checkpoint+7
		AddNewRoadPiece(RoadBlock(CurLevel,a),0,0,(a-CheckPoint)*20)
	Next
	CurRoadBlock=CheckPoint+7:Traveled=0
		
	For FireSpot.FireSpotType=Each FireSpotType:Delete FireSpot:Next
	For Flame.FlameType=Each FlameType:FreeEntity Flame\sprite:Delete Flame:Next
	For Smoke.SmokeType=Each SmokeType:FreeEntity Smoke\sprite:Delete Smoke:Next
	EngineChannel=PlaySound(EngineSound)
	ChannelVolume EngineChannel,0.15
End Function

Function UpdateHUD()
	Lives2=Lives-1
	If Lives2<0 Then Lives2=0
	SetFont(Font(res2)):Color 0,0,0
	Text 0.1*resx,0.016666667*resy,"MPH: "+Int(Speed),True,False
	Text 0.9375*resx,0.0166666667*resy,Score,True,False
	Text 0.9375*resx,0.08*resy,Lives2,True,False
	If Cheat=True Then Text 0.1*resx,0.08*resy,"CHEAT",True,False
	
	If JumpWarn=True And GameOver=False Then
		Blink=Blink+1
		If Blink>20 Then Blink=1
		If Blink>10 And Blink<=20 Then
			SetFont(Font(3+res2)):Color 0,0,0
			Text 0.5*resx,(1/6)*Resy,"(!)",True,False
			Color 255,255,255
			Text (0.5*resx)-2,((1/6)*Resy)-2,"(!)",True,False
		EndIf
	EndIf
End Function

Function UpdateVictoryScreen()
	SetFont Font(3+res2)
	If VictoryTimer>=1 Then 
		Color 0,0,0:Text (0.5*resx)+3,(0.1*resy)+3,"WELL DONE",True,False
		Color 255,255,255:Text 0.5*resx,0.1*resy,"WELL DONE",True,False
	EndIf
	
	If VictoryTimer>=50 Then
		Color 0,0,0:Text (0.02*resx)+3,(0.3*resy)+3,"Cars Crashed:",False,False
		Text (0.64*resx)+3,(0.3*resy+3),CarsCrashed,False,False
		Color 255,255,255:Text 0.02*resx,0.3*resy,"Cars Crashed:",False,False
		Text 0.64*resx,0.3*resy,CarsCrashed,False,False
	EndIf
	
	If VictoryTimer>=100 Then
		Color 0,0,0:Text (0.02*resx)+3,(0.4*resy)+3,"Bonus Points:",False,False
		Text (0.64*resx)+3,(0.4*resy)+3,CarsCrashed*100,False,False
		Color 255,255,255:Text 0.02*resx,0.4*resy,"Bonus Points:",False,False
		Text 0.64*resx,0.4*resy,CarsCrashed*100,False,False
		If VictoryTimer=100 Then AddScore(CarsCrashed*100)
	EndIf
	
	If VictoryTimer>=150 Then
		Color 0,0,0:Text (0.02*resx)+3,(0.5*resy)+3,"Next Level:",False,False
		Text (0.63*resx)+3,(0.5*resy)+3,CurLevel+1,False,False
		Color 255,255,255:Text 0.02*resx,0.5*resy,"Next Level:",False,False
		Text 0.63*resx,0.5*resy,CurLevel+1,False,False
	EndIf
	
	If VictoryTimer>=200 Then
		ns=Season+1:If ns>4 Then ns=1
		If CurLevel=1 Then ns=1
		If ns=1 Then 
			s$="Spring":c1=100:c2=255:c3=100
		EndIf
		If ns=2 Then
			s$="Summer":c1=0:c2=200:c3=0
		EndIf
		If ns=3 Then
			s$="Fall":c1=255:c2=100:c3=0
		EndIf
		If ns=4 Then
			s$="Winter":c1=255:c2=255:c3=255
		EndIf
		Color 0,0,0:Text (0.02*resx)+3,(0.6*resy)+3,"Next Season:",False,False
		Text (0.63*resx)+3,(0.6*resy)+3,s$,False,False
		Color 255,255,255:Text 0.02*resx,0.6*resy,"Next Season:",False,False
		Color c1,c2,c3:Text 0.63*resx,0.6*resy,s$,False,False	
	EndIf
	
	
	;well done
	;CARS CRASHED
	;BONUS POINTS
	;next level
	;next season
	
End Function

Function KillPlayerCar(f)
	PlayerDeathTimer=1
	HideEntity PlayerCarPart(1):Speed=0:HideEntity PlayerCarShadowSprite
	AddExplosion(EntityX(PlayerCarPart(1)),EntityY(PlayerCarPart(1)),EntityZ(PlayerCarPart(1)),70,0.5)
	If f=True Then AddFire(EntityX(PlayerCarPart(1)),EntityY(PlayerCarPart(1)),EntityZ(PlayerCarPart(1)))
	StopChannel EngineChannel:StopChannel JumpChannel
	SoundVolume LargeExplosionSound,0.7
	PlaySound LargeExplosionSound
End Function

Function KillEnemyCar(c,f)
	If EnemyExist(c)=False Then Return
	xx#=EntityX(EnemyEnt(c)):yy#=EntityY(EnemyEnt(c)):zz#=EntityZ(EnemyEnt(c))
	AddExplosion(xx,yy,zz,25,0.5)
	SoundVolume SmallExplosionSound,0.4:PlaySound(SmallExplosionSound)
	If f=True Then AddFire(xx,yy,zz)
	EnemyExist(c)=False
	FreeEntity EnemyEnt(c)	
	;CarsCrashed=CarsCrashed+1
End Function

Function UpdatePlayerCar()
	;Engine Noise
	ChannelPitch EngineChannel,20050+(Speed*20)
	;StopChannel EngineChannel
	
	;Jumping
	If JumpTimer=0 Then StopChannel(JumpChannel)
	If JumpTimer>0 Then
		If ChannelPlaying(JumpChannel)=False Then JumpChannel=PlaySound(JumpSound)
		ChannelVolume JumpChannel,0.3
		ChannelPitch JumpChannel,22050+(2500*EntityY(PlayerCarPart(1)))
		If JumpTimer=1 Then PlayerCarRotX=20:PositionEntity PlayerCarPart(1),EntityX(PlayerCarPart(1)),0.25,EntityZ(PlayerCarPart(1))
		If JumpTimer>=1 And JumpTimer<=10 Then PlayerCarMovY=PlayerCarMovY+0.024
		If JumpTimer>=1 And JumpTimer<=100 Then PlayerCarRotX=PlayerCarRotX-0.5
		JumpTimer=JumpTimer+1
		If JumpTimer>95 Then JumpTimer=0:PlayerCarRotX=0
	EndIf
		
	;Did you land on enemy car?
	If EntityY(PlayerCarPart(1))<=1 And EntityY(PlayerCarPart(1))>=0.3 And JumpTimer>50 Then 
		For a=1 To 10
			If EnemyExist(a)=True Then
				If EntityDistance(PlayerCarPart(1),EnemyEnt(a))<=1.5 Then 
					t=EnemyType(a)
					xx1#=EntityX(EnemyEnt(a)):yy1#=EntityY(EnemyEnt(a)):zz1#=EntityZ(EnemyEnt(a))
					KillEnemyCar(a,True)
					If t=2 Or t=7 Or t=9 Then AddScoringSprite(3,xx1,yy1,zz1) ;400 pts
					If t=1 Or t=4 Or t=5 Or t=8 Or t=10 Then AddScoringSprite(5,xx1,yy1,zz1) ; 600 pts
					If t=3 Or t=6 Then AddScoringSprite(6,xx1,yy1,zz1) ;1000 pts
					CarsCrashed=CarsCrashed+1
				EndIf
			EndIf
		Next
	EndIf		
	
	;Approaching end of level?
	If CurRoadBlock-7>=NumRoadBlocks(CurLevel) Then
		For a=1 To 10
			If EnemyExist(a)=True Then
				FreeEntity EnemyEnt(a):EnemyExist(a)=False
			EndIf
		Next	
			
		If EntityX(PlayerCarPart(1))>=2.5 Then PlayerCarMovX=PlayerCarMovX-0.01
		If EntityX(PlayerCarPart(1))<=1 Then PlayerCarMovX=PlayerCarMovX+0.01
		PlayerCarRotY=0
		PlayerCarMovX=PlayerCarMovX*0.95
		
		If CurRoadBlock-6>=NumRoadBlocks(CurLevel)+10 And VictoryTimer=0 Then 
			Speed=Speed-8
			If Speed<=0 Then
				Speed=0 
				StopChannel(EngineChannel):StopChannel(MusicChannel)
				MusicChannel=PlaySound(EndLevelSong)
				If MusicOff=True Then ChannelVolume MusicChannel,0
				VictoryTimer=1
			EndIf
		Else
			Speed=Speed+5
			If Speed>220 Then Speed=220
		EndIf
	EndIf
		

	If PlayerCarMovX>0.1 Then PlayerCarMovX=0.1
	If PlayerCarMovX<-0.1 Then PlayerCarMovX=-0.1
	If PlayerCarMovRotY>1 Then PlayerCarMovRotY=1
	If PlayerCarMovRotY<-1 Then PlayerCarMovRotY=-1
	PlayerCarRotY=PlayerCarRotY+PlayerCarMovRotY
	If PlayerCarRotY>15 Then PlayerCarRotY=15
	If PlayerCarRotY<-15 Then PlayerCarRotY=-15
	PlayerCarX=PlayerCarX+PlayerCarMovX
	PositionEntity PlayerCarPart(1),PlayerCarX,EntityY(PlayerCarPart(1)),3.5+(((Speed-20)/200)*2.5)
	RotateEntity PlayerCarPart(1),PlayerCarRotX,PlayerCarRotY+180,0
	
	ShadowPick=LinePick(EntityX(PlayerCarPart(1)),EntityY(PlayerCarPart(1)),EntityZ(PlayerCarPart(1)),0,-40,0)
	If ShadowPick Then 
		sx#=PickedX():sy#=PickedY()+0.001:sz#=PickedZ()
	Else 
		sy=-100:sz=0:sx=0
	EndIf
	PositionEntity PlayerCarShadowSprite,sx,sy,sz
	For a=1 To 4
		CylinderPos(a)=CylinderPos(a)+(Speed/3)
		If CylinderPos(a)>360 Then CylinderPos(a)=CylinderPos(a)-360
		PositionEntity PlayerCarPart(a+3),0,Sin(CylinderPos(a))*0.10,0
	Next
	For a=1 To 2
		PlayerCarWheelPos(a)=PlayerCarWheelPos(a)+(Speed/5)
		If PlayerCarWheelPos(a)>360 Then PlayerCarWheelPos(a)=PlayerCarWheelPos(a)-360
		If a=1 Then z=2 Else z=-2
		PositionEntity PlayerCarPart(a+1),Sin(PlayerCarWheelPos(a))*0.15,-0.5,z
		For b=2 To 3
			TurnEntity PlayerCarPart(b),-Speed/10,0,0
		Next
	Next
	
	;Falling and Collisions
	xx#=EntityX(PlayerCarPart(1)):yy#=EntityY(PlayerCarPart(1)):zz#=EntityZ(PlayerCarPart(1)):colldist#=0.3:falldist#=0.23
	FallPickPos=LinePick(xx,yy,zz,0,-falldist,0)
	If FallPickPos Then
		If EntityY(PlayerCarPart(1))<=-4 Then KillPlayerCar(False)
		PositionEntity PlayerCarPart(1),xx,PickedY()+falldist,zz
		CanJump=True
		If JumpTimer=0 Then PlayerCarMovY=0
	Else
		PlayerCarMovY=PlayerCarMovY-0.005
		CanJump=False
		If PlayerCarMovY<=-0.2 Then PlayerCarMovY=-0.2
		TranslateEntity PlayerCarPart(1),0,PlayerCarMovY,0
	EndIf
	
	;Off the road?
	If JumpTimer=0 And (xx>=4.5 Or xx<=-4.5) Then KillPlayerCar(True)
	
	;Check For Collisions with scenery
	yy=yy+0.1
	CarPickPos(1)=LinePick(xx,yy,zz+0.4,0,0,Colldist)
	CarPickPos(2)=LinePick(xx+0.2,yy,zz+0.25,Colldist,0,0)
	CarPickPos(3)=LinePick(xx+0.2,yy,zz+0.25,Colldist,0,0)
	CarPickPos(4)=LinePick(xx,yy,zz-0.4,0,0,-Colldist)
	CarPickPos(5)=LinePick(xx-0.2,yy,zz-0.25,-Colldist,0,-0)
	CarPickPos(6)=LinePick(xx-0.2,yy,zz-0.25,-Colldist,0,0)
	For a=1 To 6
		If CarPickPos(a)<>0 And PlayerDeathTimer=0 Then KillPlayerCar(True)
	Next
	
	;Check for collisions with other cars
	For a=1 To 10
		If EnemyExist(a)=True Then
			If EntityDistance(PlayerCarPart(1),EnemyEnt(a))<=0.75 Then
				ex#=EntityX(EnemyEnt(a)):ey#=EntityY(EnemyEnt(a)):ez#=EntityZ(EnemyEnt(a))
				If EnemyType(a)=5 Then KillEnemyCar(a,True):AddScoringSprite(2,ex,ey,ez)
				If EnemyType(a)<>5 Then 
					f#=1.1
					If xx>ex And zz>ez Then BumpCar(0,1,f):BumpCar(a,3,f*EnemyWeight(a))
					If xx>ex And zz<ez Then BumpCar(0,2,f):BumpCar(a,4,f*EnemyWeight(a))
					If xx<ex And zz<ez Then BumpCar(0,3,f):BumpCar(a,1,f*EnemyWeight(a))
					If xx<ex And zz>ez Then BumpCar(0,4,f):BumpCar(a,2,f*EnemyWeight(a))
					PlaySound BumpSound					
					EnemyBumped(a)=True
				EndIf
			EndIf
		EndIf
	Next
	
End Function

Function SetUpStartRoad()
	ScaleEntity SkyDomeMesh,300,30,300
	PositionEntity PlayerCarPart(1),0,0.23,5
	PositionEntity Camera,0,5,0:RotateEntity Camera,30,0,0
	For a=1 To 8:AddNewRoadPiece(RoadBlock(CurLevel,a),0,0,(a-1)*20):Next:CurRoadBlock=1
	For a=1 To 2
		CloudMov(a)=Rnd(-0.0003,0.0003)
		CloudPos(a)=0
	Next
	PlayerCarShadowSprite=CopyEntity(CarShadowSprite)
	PositionEntity PlayerCarShadowSprite,EntityX(PlayerCarPart(1)),0.001,EntityZ(PlayerCarPart(1))
	RotateEntity PlayerCarShadowSprite,90,0,0:ScaleSprite PlayerCarShadowSprite,0.8,0.65
	PlayerCarX=0:PlayerCarMovX=0:PlayerCarRotY=0:PlayerCarRotMovY=0
End Function

Function UpdateRoadTravel()
	jumpwarn=False
	For RoadPiece.RoadPieceType=Each RoadPieceType
		;Jump warning
		t=RoadPiece\typ
		If t=0 Or (t>=15 And t<=20) Then jumpwarn=True
	
		TranslateEntity RoadPiece\a01,0,0,-(Speed/220)
		WaterPos=WaterPos+((Speed/220)/290)
		If WaterPos<0 Then WaterPos=WaterPos+1
		WaterDir=WaterDir+WaterSpeed
		If WaterDir>1 Then WaterDir=WaterDir-1
		If WaterDir<-1 Then WaterDir=WaterDir+1
		PositionTexture WaterTex(Season),WaterDir,WaterPos
		If EntityZ(RoadPiece\a01)<-30 Then FreeEntity RoadPiece\a01:Delete RoadPiece
	Next
	
	If GameOver=True Then JumpWarn=False
	
	ChannelVolume JumpWarningChannel,0.8
	If jumpwarn=True Then
		If ChannelPlaying(JumpWarningChannel)=False Then JumpWarningChannel=PlaySound(JumpWarningSound)
	Else
		StopChannel(JumpWarningChannel)
	EndIf
		
	;UpdateSky
	For a=1 To 2
		CloudPos(a)=CloudPos(a)+CloudMov(a)
		If CloudPos(a)>1 Then CloudPos(a)=CloudPos(a)-1
		If CloudPos(a)<-1 Then CloudPos(a)=CloudPos(a)+1
	Next
	PositionTexture SkyTex(Season),CloudPos(1),CloudPos(2)
	
	If Traveled>=20 Then
		CurRoadBlock=CurRoadBlock+1
		If CurRoadBlock>NumRoadBlocks(CurLevel) Then 
			If CurRoadBlock=NumRoadBlocks(CurLevel)+10 Then xxx=23 Else xxx=1
		Else 
			xxx=RoadBlock(CurLevel,CurRoadBlock)
		EndIf
		AddNewRoadPiece(xxx,0,0,140-(Traveled-20))
		Traveled=Traveled-20
		
		;Add cars?
		If Rand(1,3)=1 And (xxx<15 Or xxx>20) And GameOver=False Then
			cx#=Rnd(-4.5,4.5)
			;Car appears only on left
			If xxx=3 Or xxx=4 Or xxx=9 Then cx=Rnd(-4.5,0)
			;Car on right
			If xxx=6 Or xxx=7 Or xxx=8 Then cx=Rnd(0,4.5)
			;car on right or left but not center
			If xxx=11 Or xxx=12 Then
				If Rand(1,2)=1 Then 
					cx=Rnd(-4.5,-2)
				Else
					cx=Rnd(2,4.5)
				EndIf
			EndIf
			
			If Rand(1,2)=1 Then 
				AddEnemyCar(Rand(1,10),cx#,117)
			Else
				If Speed<150 Then 
					AddEnemyCar(Rand(1,10),Rnd(-4.25,4.25),-5) 
				Else 
					AddEnemyCar(Rand(1,10),cx#,117)
				EndIf
			EndIf
		
		EndIf
		
		
	EndIf
	CheckPoint=1
	For a=20 To (NumRoadBlocks(CurLevel)-20) Step 20
		If (CurRoadBlock-7)>=a Then CheckPoint=a
	Next	
End Function

Function AddNewRoadPiece(t,x#,y#,z#)
	RoadPiece.RoadPieceType=New RoadPiecetype
	RoadPiece\typ=t
	;0=open gap
	If t=0 Then
		RoadPiece\a01=CreateCube():HideEntity RoadPiece\a01
	EndIf
	;1=plain road, fence on both sides
	;10=start of central divider
	;11=central divider
	;12=end of central divider
	;23=gas station
	If t=1 Or t=10 Or t=11 Or t=12 Or t=21 Or t=23 Then
		RoadPiece\a01=CopyEntity(RoadPieceMesh(1))
		RoadPiece\a02=CopyEntity(RoadPieceMesh(2),RoadPiece\a01):TranslateEntity RoadPiece\a02,5,0,0
		RoadPiece\a03=CopyEntity(RoadPieceMesh(2),RoadPiece\a01):TranslateEntity RoadPiece\a03,-5,0,0
		If t=11 Then
			RoadPiece\a04=CopyEntity(RoadPieceMesh(2),RoadPiece\a01):TranslateEntity RoadPiece\a04,1,0,0
			RoadPiece\a05=CopyEntity(RoadPieceMesh(2),RoadPiece\a01):TranslateEntity RoadPiece\a05,-1,0,0
			RoadPiece\a06=CopyEntity(RoadPieceMesh(12),RoadPiece\a01)
		EndIf
		If t=10 Or t=12 Then 
			RoadPiece\a07=CopyEntity(RoadPieceMesh(10),RoadPiece\a01):RoadPiece\a08=CopyEntity(RoadPieceMesh(11),RoadPiece\a01)
			If t=12 Then RotateEntity RoadPiece\a07,0,180,0:RotateEntity RoadPiece\a08,0,180,0
		EndIf
		If t=23 Then
			RoadPiece\GasStation=CopyEntity(RoadPieceMesh(20),RoadPiece\a01):TranslateEntity RoadPiece\GasStation,0,0.005,0
		EndIf
	EndIf 
	;2=rough starting on R
	If t=2 Then
		RoadPiece\a01=CopyEntity(RoadPieceMesh(1))
		RoadPiece\a02=CopyEntity(RoadPieceMesh(3),RoadPiece\a01)
		RoadPiece\a03=CopyEntity(RoadPieceMesh(2),RoadPiece\a01):TranslateEntity RoadPiece\a03,-5,0,0
		RoadPiece\a04=CopyEntity(RoadPieceMesh(9),RoadPiece\a01):TranslateEntity RoadPiece\a04,5,0,-5
	EndIf
	;3=rough on R
	If t=3 Then
		RoadPiece\a01=CopyEntity(RoadPieceMesh(1))
		RoadPiece\a02=CopyEntity(RoadPieceMesh(4),RoadPiece\a01)
		RoadPiece\a03=CopyEntity(RoadPieceMesh(2),RoadPiece\a01):TranslateEntity RoadPiece\a03,-5,0,0
	EndIf
	;4=rough ends on R
	If t=4 Then
		RoadPiece\a01=CopyEntity(RoadPieceMesh(1))
		RoadPiece\a02=CopyEntity(RoadPieceMesh(5),RoadPiece\a01)
		RoadPiece\a03=CopyEntity(RoadPieceMesh(9),RoadPiece\a01):TranslateEntity RoadPiece\a03,5,0,5
		RoadPiece\a04=CopyEntity(RoadPieceMesh(2),RoadPiece\a01):TranslateEntity RoadPiece\a04,-5,0,0
	EndIf
	;5=rough starting on L
	If t=5 Then
		RoadPiece\a01=CopyEntity(RoadPieceMesh(1))
		RoadPiece\a02=CopyEntity(RoadPieceMesh(6),RoadPiece\a01)
		RoadPiece\a03=CopyEntity(RoadPieceMesh(2),RoadPiece\a01):TranslateEntity RoadPiece\a03,5,0,0
		RoadPiece\a04=CopyEntity(RoadPieceMesh(9),RoadPiece\a01):TranslateEntity RoadPiece\a04,-5,0,-5
	EndIf
	;6=rough on L
	If t=6 Then
		RoadPiece\a01=CopyEntity(RoadPieceMesh(1))
		RoadPiece\a02=CopyEntity(RoadPieceMesh(7),RoadPiece\a01)
		RoadPiece\a03=CopyEntity(RoadPieceMesh(2),RoadPiece\a01):TranslateEntity RoadPiece\a03,5,0,0
	EndIf
	;7=rough ends on L
	If t=7 Then
		RoadPiece\a01=CopyEntity(RoadPieceMesh(1))
		RoadPiece\a02=CopyEntity(RoadPieceMesh(8),RoadPiece\a01)
		RoadPiece\a03=CopyEntity(RoadPieceMesh(9),RoadPiece\a01):TranslateEntity RoadPiece\a03,-5,0,5
		RoadPiece\a04=CopyEntity(RoadPieceMesh(2),RoadPiece\a01):TranslateEntity RoadPiece\a04,5,0,0
	EndIf
	;8=rough ends on L and starts on R
	If t=8 Then
		RoadPiece\a01=CopyEntity(RoadPieceMesh(1))
		RoadPiece\a02=CopyEntity(RoadPieceMesh(9),RoadPiece\a01):TranslateEntity RoadPiece\a02,-5,0,5
		RoadPiece\a03=CopyEntity(RoadPieceMesh(9),RoadPiece\a01):TranslateEntity RoadPiece\a03,5,0,-5
		RoadPiece\a04=CopyEntity(RoadPieceMesh(8),RoadPiece\a01)
		RoadPiece\a05=CopyEntity(RoadPieceMesh(3),RoadPiece\a01)
	EndIf
	;9=rough ends on R and starts on L
	If t=9 Then
		RoadPiece\a01=CopyEntity(RoadPieceMesh(1))
		RoadPiece\a02=CopyEntity(RoadPieceMesh(9),RoadPiece\a01):TranslateEntity RoadPiece\a02,5,0,5
		RoadPiece\a03=CopyEntity(RoadPieceMesh(9),RoadPiece\a01):TranslateEntity RoadPiece\a03,-5,0,-5
		RoadPiece\a04=CopyEntity(RoadPieceMesh(6),RoadPiece\a01)
		RoadPiece\a05=CopyEntity(RoadPieceMesh(5),RoadPiece\a01)
	EndIf
	;13=Rocks on left  14=rocks on right 
	If t=13 Or t=14 Then
		RoadPiece\a01=CopyEntity(RoadPieceMesh(1))
		RoadPiece\a02=CopyEntity(RoadPieceMesh(2),RoadPiece\a01)
		RoadPiece\a03=CopyEntity(RoadPieceMesh(13),RoadPiece\a01)
		If t=13 Then TranslateEntity RoadPiece\a02,5,0,0:TranslateEntity RoadPiece\a03,-4.5,0,0
		If t=14 Then TranslateEntity RoadPiece\a02,-5,0,0:TranslateEntity RoadPiece\a03,4.5,0,0
	EndIf
	;22=rocks on both sides
	If t=22 Then
		RoadPiece\a01=CopyEntity(RoadPieceMesh(1))
		RoadPiece\a02=CopyEntity(RoadPieceMesh(13),RoadPiece\a01)
		RoadPiece\a03=CopyEntity(RoadPieceMesh(13),RoadPiece\a01)
		TranslateEntity RoadPiece\a02,4.5,0,0:TranslateEntity RoadPiece\a03,-4.5,0,0
	EndIf
	;15=causeway left  16=causeway middle  17=causeway right
	;18=causeway left with small island   19=causewayright with small island
	If t>=15 And t<=19 Then
		RoadPiece\a01=CopyEntity(RoadPieceMesh(14))
		PositionEntity RoadPiece\a01,x,y,z
		RoadPiece\a02=CopyEntity(RoadPieceMesh(2),RoadPiece\a01):TranslateEntity RoadPiece\a02,1.5,0,0
		RoadPiece\a03=CopyEntity(RoadPieceMesh(2),RoadPiece\a01):TranslateEntity RoadPiece\a03,-1.5,0,0
		If t=15 Or t=18 Then TranslateEntity RoadPiece\a01,-3,0,0
		If t=17 Or t=19 Then TranslateEntity RoadPiece\a01,3,0,0
		If t=18 Or t=19 Then
			RoadPiece\a04=CopyEntity(RoadPieceMesh(16),RoadPiece\a01):EntityPickMode RoadPiece\a04,2
			If t=18 Then TranslateEntity RoadPiece\a04,6,0,0 Else TranslateEntity RoadPiece\a04,-6,0,0
		EndIf
	EndIf
	;20=Large Island Alone
	If t=20 Then
		RoadPiece\a01=CopyEntity(RoadPieceMesh(17))
	EndIf
	;Land Slices, trees, and billboards
	If (t>=1 And t<=14) Or t=22 Or t=23 Then 
		RoadPiece\ls1=CopyEntity(RoadPieceMesh(18),RoadPiece\a01):EntityAutoFade RoadPiece\ls1,100,140
		RoadPiece\ls2=CopyEntity(RoadPieceMesh(18),RoadPiece\a01):EntityAutoFade RoadPiece\ls2,100,140
		TranslateEntity RoadPiece\ls1,5,0,0
		TranslateEntity RoadPiece\ls2,-5,0,0:RotateEntity RoadPiece\ls2,0,180,0
		If t=1 Or t=5 Or t=6 Or t=7 Or t=10 Or t=11 Or t=12 Or t=13 Or t=14 Or t=22 Then
			;Trees on right
			RoadPiece\t11=CopyEntity(RoadPieceMesh(15),RoadPiece\a01):RoadPiece\t12=CopyEntity(RoadPieceMesh(15),RoadPiece\a01):RoadPiece\t13=CopyEntity(RoadPieceMesh(15),RoadPiece\a01)
			RoadPiece\t14=CopyEntity(RoadPieceMesh(15),RoadPiece\a01):RoadPiece\t15=CopyEntity(RoadPieceMesh(15),RoadPiece\a01):RoadPiece\t16=CopyEntity(RoadPieceMesh(15),RoadPiece\a01)
			RoadPiece\t17=CopyEntity(RoadPieceMesh(15),RoadPiece\a01):RoadPiece\t18=CopyEntity(RoadPieceMesh(15),RoadPiece\a01):RoadPiece\t19=CopyEntity(RoadPieceMesh(15),RoadPiece\a01)
			TranslateEntity RoadPiece\t11,Rnd(5.5,7),0,Rnd(-10,10):RotateEntity RoadPiece\t11,0,Rnd(0,359),0		
			TranslateEntity RoadPiece\t12,Rnd(5.5,7),0,Rnd(-10,10):RotateEntity RoadPiece\t12,0,Rnd(0,359),0		
			TranslateEntity RoadPiece\t13,Rnd(5.5,7),0,Rnd(-10,10):RotateEntity RoadPiece\t13,0,Rnd(0,359),0		
			TranslateEntity RoadPiece\t14,Rnd(5.5,7),0,Rnd(-10,10):RotateEntity RoadPiece\t14,0,Rnd(0,359),0		
			TranslateEntity RoadPiece\t15,Rnd(5.5,7),0,Rnd(-10,10):RotateEntity RoadPiece\t15,0,Rnd(0,359),0		
			TranslateEntity RoadPiece\t16,Rnd(5.5,7),0,Rnd(-10,10):RotateEntity RoadPiece\t16,0,Rnd(0,359),0		
			TranslateEntity RoadPiece\t17,Rnd(5.5,7),0,Rnd(-10,10):RotateEntity RoadPiece\t17,0,Rnd(0,359),0		
			TranslateEntity RoadPiece\t18,Rnd(5.5,7),0,Rnd(-10,10):RotateEntity RoadPiece\t18,0,Rnd(0,359),0		
			TranslateEntity RoadPiece\t19,Rnd(5.5,7),0,Rnd(-10,10):RotateEntity RoadPiece\t19,0,Rnd(0,359),0	
		EndIf
		If t=1 Or t=2 Or t=3 Or t=4 Or t=10 Or t=11 Or t=12 Or t=13 Or t=14 Or t=22 Then
		;Trees on left
			RoadPiece\t21=CopyEntity(RoadPieceMesh(15),RoadPiece\a01):RoadPiece\t22=CopyEntity(RoadPieceMesh(15),RoadPiece\a01):RoadPiece\t23=CopyEntity(RoadPieceMesh(15),RoadPiece\a01)
			RoadPiece\t24=CopyEntity(RoadPieceMesh(15),RoadPiece\a01):RoadPiece\t25=CopyEntity(RoadPieceMesh(15),RoadPiece\a01):RoadPiece\t26=CopyEntity(RoadPieceMesh(15),RoadPiece\a01)
			RoadPiece\t27=CopyEntity(RoadPieceMesh(15),RoadPiece\a01):RoadPiece\t28=CopyEntity(RoadPieceMesh(15),RoadPiece\a01):RoadPiece\t29=CopyEntity(RoadPieceMesh(15),RoadPiece\a01)
			TranslateEntity RoadPiece\t21,Rnd(-5.5,-7),0,Rnd(-10,10):RotateEntity RoadPiece\t21,0,Rnd(0,359),0		
			TranslateEntity RoadPiece\t22,Rnd(-5.5,-7),0,Rnd(-10,10):RotateEntity RoadPiece\t22,0,Rnd(0,359),0		
			TranslateEntity RoadPiece\t23,Rnd(-5.5,-7),0,Rnd(-10,10):RotateEntity RoadPiece\t23,0,Rnd(0,359),0		
			TranslateEntity RoadPiece\t24,Rnd(-5.5,-7),0,Rnd(-10,10):RotateEntity RoadPiece\t24,0,Rnd(0,359),0		
			TranslateEntity RoadPiece\t25,Rnd(-5.5,-7),0,Rnd(-10,10):RotateEntity RoadPiece\t25,0,Rnd(0,359),0		
			TranslateEntity RoadPiece\t26,Rnd(-5.5,-7),0,Rnd(-10,10):RotateEntity RoadPiece\t26,0,Rnd(0,359),0		
			TranslateEntity RoadPiece\t27,Rnd(-5.5,-7),0,Rnd(-10,10):RotateEntity RoadPiece\t27,0,Rnd(0,359),0		
			TranslateEntity RoadPiece\t28,Rnd(-5.5,-7),0,Rnd(-10,10):RotateEntity RoadPiece\t28,0,Rnd(0,359),0		
			TranslateEntity RoadPiece\t29,Rnd(-5.5,-7),0,Rnd(-10,10):RotateEntity RoadPiece\t29,0,Rnd(0,359),0		
		EndIf
		;Place a billboard?
		If Rand(1,10)=1 Then
			RoadPiece\billboard=CopyEntity(RoadPieceMesh(19),RoadPiece\a01)
			RoadPiece\billboardad=CopyEntity(BillBoardAdMesh,RoadPiece\billboard)
			EntityTexture RoadPiece\billboardad,BillBoardAdTex(Rand(1,15))
			;right or left?
			If Rand(1,2)=1 Then zz=1 Else zz=-1
			PositionEntity RoadPiece\billboard,8*zz,-2,Rnd(-5,5)
			RotateEntity RoadPiece\billboard,0,-25*zz,0
		EndIf
	EndIf
	If t>19 Or t<15 Then PositionEntity RoadPiece\a01,x,y,z
	EntityPickMode RoadPiece\a01,2
	EntityAutoFade RoadPiece\a01,100,140
End Function

Function AddDebris(x#,z#)
	Debris.DebrisType=New DebrisType
	Debris\entity=CopyEntity(DebrisMesh)
	PositionEntity Debris\entity,x,0,z
End Function

Function UpdateDebris()
	For Debris.DebrisType=Each DebrisType
		TranslateEntity Debris\entity,0,0,-(Speed/220)
		If EntityZ(Debris\entity)<=-5 Then FreeEntity Debris\entity:Delete Debris
	Next
End Function

Function AddFire(x#,y#,z#)
	FireSpot.FireSpotType=New FireSpotType
	FireSpot\x=x:FireSpot\y=y:FireSpot\z=z
End Function

Function AddFlame(x#,y#,z#)
	Flame.FlameType=New FlameType
	Flame\sprite=CopyEntity(FlameSprite)
	Flame\alpha=1
	Flame\faderate=Rnd(0.005,0.02)
	Flame\riserate=Rnd(0.005,0.05)
	PositionEntity Flame\sprite,x,y,z
End Function

Function AddSmoke(x#,y#,z#)
	Smoke.SmokeType=New SmokeType
	Smoke\sprite=CopyEntity(SmokeSprite)
	Smoke\alpha=1
	Smoke\faderate=Rnd(0.005,0.01)
	Smoke\spinrate=Rnd(-2,2)
	Smoke\angle=Rnd(0,359)
	Smoke\riserate=Rnd(0.05,0.1)
	PositionEntity Smoke\sprite,x,y,z	
End Function

Function AddExplosion(x#,y#,z#,numpart,scale#)
	For a=1 To numpart
		AddParticle(x+Rnd(-0.25,0.25),y+Rnd(0,0.25),z+Rnd(-0.25,0.25),Rnd(-0.25,0.25)*scale,Rnd(0,0.25)*scale,Rnd(-0.25,0.25)*scale,Rnd(0.5,2))
	Next
End Function

Function AddParticle(x#,y#,z#,mx#,my#,mz#,sc#)
	Particle.ParticleType=New ParticleType
	Particle\sprite=CopyEntity(ParticleSprite)
	ScaleSprite Particle\sprite,sc,sc
	EntityColor Particle\sprite,255,255,255
	Particle\mx=mx:Particle\my=my:Particle\mz=mz
	Particle\r=255:Particle\g=255:Particle\b=255
	Particle\dr=Rnd(0.5,1):Particle\dg=Rnd(1,2.5):Particle\db=Rnd(2.5,7)
	Particle\alpha=1:Particle\faderate=Rnd(0.005,0.01)
	PositionEntity Particle\sprite,x,y,z
End Function

Function UpdateParticles()
	For Particle.ParticleType=Each ParticleType
		Particle\my=Particle\my-0.005
		TranslateEntity Particle\sprite,Particle\mx,Particle\my,Particle\mz
		TranslateEntity Particle\sprite,0,0,-Speed/220
		Particle\r=Particle\r-Particle\dr
		Particle\g=Particle\g-Particle\dg
		Particle\b=Particle\b-Particle\db
		Particle\alpha=Particle\alpha-Particle\faderate
		EntityAlpha Particle\sprite,Particle\alpha
		EntityColor Particle\sprite,Particle\r,Particle\g,Particle\b
		
		If Particle\alpha<=0 Or EntityZ(Particle\sprite)<-5 Then FreeEntity Particle\sprite:Delete Particle	
	Next
End Function

Function UpdateFires()
	For FireSpot.FireSpotType=Each FireSpotType
		FireSpot\z=FireSpot\z-(Speed/220)
		If Rand(1,6)=1 Then AddFlame(FireSpot\x+Rnd(-0.5,0.5),FireSpot\y,FireSpot\z+Rnd(-0.5,0.5))
		If Rand(1,4)=1 Then AddSmoke(FireSpot\x+Rnd(-0.5,0.5),FireSpot\y,FireSpot\z+Rnd(-0.5,0.5))
		If FireSpot\z<=-20 Then Delete FireSpot
	Next
	
	For Flame.FlameType=Each FlameType
		TranslateEntity Flame\sprite,0,Flame\riserate,-(Speed/220)
		Flame\alpha=Flame\alpha-Flame\faderate:If Flame\alpha<0 Then Flame\alpha=0
		EntityAlpha Flame\sprite,Flame\alpha
		If Flame\alpha=0 Then FreeEntity Flame\sprite:Delete Flame
	Next
	For Smoke.SmokeType=Each SmokeType
		TranslateEntity Smoke\sprite,0,Smoke\riserate,-(Speed/220)
		Smoke\angle=Smoke\angle+Smoke\spinrate
		If Smoke\angle>=360 Then Smoke\angle=Smoke\angle-360
		If Smoke\angle<0 Then Smoke\angle=Smoke\angle+360
		RotateSprite Smoke\sprite,Smoke\angle
		Smoke\alpha=Smoke\alpha-Smoke\faderate:If Smoke\alpha<0 Then Smoke\alpha=0
		EntityAlpha Smoke\sprite,Smoke\alpha
		If Smoke\alpha=0 Then FreeEntity Smoke\sprite:Delete Smoke
	Next
End Function

Function AddScoringSprite(t,x#,y#,z#) ;200,300,400,500,600,1000
	Scoring.ScoringType=New ScoringType
	Scoring\sprite=CopyEntity(ScoringSprite(t))
	PositionEntity Scoring\sprite,x,y,z
	Scoring\life=0
	Scoring\alpha=1
	If t=1 Then AddScore(200)
	If t=2 Then AddScore(300)
	If t=3 Then AddScore(400)
	If t=4 Then AddScore(500)
	If t=5 Then AddScore(600)
	If t=6 Then AddScore(1000)
End Function

Function UpdateScoringSprites()
	For Scoring.ScoringType=Each ScoringType
		Scoring\life=Scoring\life+1
		If Scoring\life>50 Then
			Scoring\alpha=Scoring\alpha-0.02
			EntityAlpha Scoring\sprite,Scoring\alpha
		EndIf
		If Scoring\alpha<=0 Then FreeEntity Scoring\sprite:Delete Scoring
	Next
End Function

Function AddEnemyCar(t,x#,z#)
	;If t=5 Then Return
	;Only one dump truck on screen at any one time!!
	;If t=5 Then
	;	For a=1 To 10
	;		If EnemyExist(a)=True And EnemyType(a)=5 Then Return
	;	Next
	;EndIf
	For a=1 To 10
	If EnemyExist(a)=False Then
		EnemyExist(a)=True
		EnemyType(a)=t
		EnemyBumped(a)=False
		EnemyDumpTimer(a)=0
		EnemyEnt(a)=CopyEntity(EnemyCarMesh(t))
		EnemyShadow(a)=CopyEntity(CarShadowSprite)
		PositionEntity EnemyEnt(a),x,0,z:RotateEntity EnemyEnt(a),0,0,0
		PositionEntity EnemyShadow(a),x,0.005,z
		RotateEntity EnemyShadow(a),90,0,0
		ScaleSprite EnemyShadow(a),1.3,1.2
		EntityParent EnemyShadow(a),EnemyEnt(a)

		If Rand(1,2)=1 Then EnemyWeaveDir(a)=1 Else EnemyWeaveDir(a)=-1
		EnemyWeaveCount(a)=Rand(20,50)
		
		EntityBox EnemyEnt(a),-0.2,-0.2,-0.4,0.4,0.4,1
		EntityRadius EnemyEnt(a),0.4
		ew#=0:es#=0
		If t=1 Then ew=0.4:es=Rand(105,130)								;Tractor
		If t=2 Then ew=1:es=Rand(140,210)								;Cycle
		If t=3 Then ew=0.75:Rand(110,200)								;Skull Car
		If t=4 Then ew=0.85:es=Rand(180,210)							;Race Car
		If t=5 Then ew=1:es=Rand(140,180)								;Dump Truck
		If t=6 Then ew=1:Rand(110,200)									;White Car
		If t=7 Then ew=0.5:es=Rand(110,155)								;Yellow Truck
		If t=8 Then ew=1:es=Rand(120,180)								;Green Car
		If t=9 Then ew=0.75:es=Rand(120,180)							;Blue Car
		If t=10 Then ew=0.65:es=Rand(130,180)							;Brown car
		es=Rand(70,150)
		EnemyWeight(a)=ew:EnemySpeed(a)=es
		EnemySpeedMaint(a)=EnemySpeed(a)
		EnemyMX(a)=0:EnemyMY(a)=0:EnemyMZ(a)=0:EnemyFalling(a)=False
		Return
	EndIf
	Next

End Function

Function UpdateEnemyCars()
	For a=1 To 10
	If EnemyExist(a)=True Then
		If EnemyMZ(a)>0 Then EnemySpeed(a)=EnemySpeed(a)+2:EnemyMZ(a)=EnemyMZ(a)-1
		If EnemyMZ(a)<0 Then EnemySpeed(a)=EnemySpeed(a)-2:EnemyMZ(a)=EnemyMZ(a)+1
		
		;EntityAlpha(EnemyEnt(a)),1
		;If EnemyBumped(a)=True Then EntityAlpha(EnemyEnt(a)),0.3

		;If EntityY(EnemyEnt(a))<>0 And EnemyFalling(a)=False Then PositionEntity EnemyEnt(a),EntityX(EnemyEnt(a)),0,EntityZ(EnemyEnt(a))
		mov#=(Speed-EnemySpeed(a))/220
		TranslateEntity EnemyEnt(a),EnemyMX(a),0,-mov
		EnemyMX(a)=EnemyMX(a)*0.95
		
		;Check for falling off road
		If EnemyFalling(a)=False Then 
			If EntityY(EnemyEnt(a))<>0 Then PositionEntity EnemyEnt(a),EntityX(EnemyEnt(a)),0,EntityZ(EnemyEnt(a))

			fallcheck=LinePick(EntityX(EnemyEnt(a)),EntityY(EnemyEnt(a))+0.1,EntityZ(EnemyEnt(a)),0,-0.25,0)
			If fallcheck=0 Then EnemyFalling(a)=True:HideEntity EnemyShadow(a)
			
			;Behaviors
			If EnemyMZ(a)=0 Then
				EnemyBumped(a)=False
				px#=EntityX(PlayerCarPart(1)):pz#=EntityZ(PlayerCarPart(1))
				ex#=EntityX(EnemyEnt(a)):ey#=EntityY(EnemyEnt(a)):ez#=EntityZ(EnemyEnt(a))
				t=EnemyType(a)
				
				;Animations
				If t<>5 Then
					If Animating(EnemyEnt(a))=False Then Animate EnemyEnt(a),1,0.3,1				
				EndIf
				
				;Dump Truck Animation
				If t=5 Then
					If EntityZ(EnemyEnt(a))<=60 And EnemyDumpTimer(a)=0 Then EnemyDumpTimer(a)=1
					If EnemyDumpTimer(a)=0 Then 
						If Animating(EnemyEnt(a))=False Then Animate EnemyEnt(a),1,0.3,1
					EndIf
					If EnemyDumpTimer(a)=1 Then Animate EnemyEnt(a),3,0.3,2
					If EnemyDumpTimer(a)>=1 Then EnemyDumpTimer(a)=EnemyDumpTimer(a)+1
					If EnemyDumpTimer(a)=30 Then 
						Animate EnemyEnt(a),1,0.3,3
						AddDebris(EntityX(EnemyEnt(a)),EntityZ(EnemyEnt(a))-2)
						PlaySound DumpTruckSound
					EndIf
				EndIf
				
				;Basic avoidance AI
				CarPickPos(1)=LinePick(ex,ey+0.1,ez+5,0,-1,0) ;water
				CarPickPos(2)=LinePick(ex,ey+0.1,ez,-1.5,0,0)   ;left
				CarPickPos(3)=LinePick(ex,ey+0.1,ez,1.5,0,0)    ;right
				CarPickPos(4)=LinePick(ex,ey+0.1,ez,0,0,5)    ;front
				
				If CarPickPos(1)=0 Or CarPickPos(4)<>0 Then 
					EnemySpeed(a)=EnemySpeed(a)-25
					If EnemySpeed(a)<0 Then EnemySpeed(a)=0
					Goto DoneWithAI
				EndIf
				
				If EnemyMZ(a)=0 Then 
					If CarPickPos(2)<>0 Then EnemyMX(a)=EnemyMX(a)+0.01
					If CarPickPos(3)<>0 Then EnemyMX(a)=EnemyMX(a)-0.01
				EndIf
				
				;Maintain constant speed (except for #3 and #6)
				If t<>3 And t<>6 Then
					If EnemySpeed(a)>EnemySpeedMaint(a) Then EnemySpeed(a)=EnemySpeed(a)-1
					If EnemySpeed(a)<EnemySpeedMaint(a) Then EnemySpeed(a)=EnemySpeed(a)+1		
					;If EnemySpeed(a)>=Speed-30 Then EnemySpeed(a)=EnemySpeed(a)-1
					;If EnemySpeed(a)<=Speed-30 Then EnemySpeed(a)=EnemySpeed(a)+1
				EndIf
			
				;Weaves or Zig Zags 
				If t=2 Or t=4 Or t=7 Or t=8 Or t=9 Or t=10 Then
					amt=1 ;weave
					If t=4 Or t=8 Or t=10 Then amt=2  ;zig zag
					v1#=EnemyWeaveDir(a)
					EnemyMX(a)=EnemyMX(a)+(v1*amt*Rnd(0.001,0.004))
					EnemyWeaveCount(a)=EnemyWeaveCount(a)-1
					If EnemyWeaveCount(a)<=0 Then
						EnemyWeaveDir(a)=EnemyWeaveDir(a)*-1
						EnemyWeaveCount(a)=Rand(20,50)
					EndIf
				EndIf
				
				;Goes after your car!!
				If t=3 Or t=6
					If t=6 Then mov#=0.0045 Else mov#=0.003
					If ex>px Then EnemyMX(a)=EnemyMX(a)-mov
					If ex<px Then EnemyMX(a)=EnemyMX(a)+mov
					If ez>pz+20 And (Speed-EnemySpeed(a))<120 Then EnemySpeed(a)=EnemySpeed(a)-1
					If ez>pz+4 And (Speed-EnemySpeed(a))<60 Then EnemySpeed(a)=EnemySpeed(a)-1 Else EnemySpeed(a)=EnemySpeed(a)+1
					If EnemySpeed(a)>200 And ez>pz Then EnemySpeed(a)=EnemySpeed(a)-1
					If ez<pz Then EnemySpeed(a)=EnemySpeed(a)+1
					If ez<pz-5 Then EnemySpeed(a)=EnemySpeed(a)+2
				EndIf
				
				.DoneWithAI
			EndIf
		EndIf
		
		If EnemyFalling(a)=True Then
			EnemyMY(a)=EnemyMY(a)-0.005
			If EnemyMY(a)<=-0.2 Then EnemyMY(a)=-0.2
			TranslateEntity EnemyEnt(a),0,EnemyMY(a),0
			If EntityY(EnemyEnt(a))<=-4 Then 
				KillEnemyCar(a,False)
				If EnemyBumped(a)=True Then
					CarsCrashed=CarsCrashed+1
					xx1#=EntityX(EnemyEnt(a)):yy1#=EntityY(EnemyEnt(a)):zz1#=EntityZ(EnemyEnt(a))
					If t=2 Or t=7 Or t=9 Then AddScoringSprite(1,xx1,yy1,zz1)
					If t=1 Or t=4 Or t=5 Or t=8 Or t=10 Then AddScoringSprite(2,xx1,yy1,zz1)
					If t=3 Or t=6 Then AddScoringSprite(3,xx1,yy1,zz1)
				EndIf
				Goto done1
			EndIf
		EndIf
		
		
		If EnemySpeed(a)>210 Then EnemySpeed(a)=210
		If EnemySpeed(a)<0 Then EnemySpeed(a)=0		
		If EntityZ(EnemyEnt(a))<=-10 Or EntityZ(EnemyEnt(a))>125 Then FreeEntity EnemyEnt(a):EnemyExist(a)=False
		.done1
	EndIf
	Next
	
	;Check For Collisions with other cars
	For a=1 To 10
	If EnemyExist(a)=True Then
		xx1#=EntityX(EnemyEnt(a)):yy1#=EntityY(EnemyEnt(a)):zz1#=EntityZ(EnemyEnt(a))
		
		For c=1 To 10
			If EnemyExist(c)=True And c<>a Then
				If EntityDistance(EnemyEnt(a),EnemyEnt(c))<=0.75 Then
					xx2#=EntityX(EnemyEnt(c)):yy2#=EntityY(EnemyEnt(c)):zz2#=EntityZ(EnemyEnt(c))
					f#=1.1
					
					f#=0.2
					If xx1>xx2 And zz1>zz2 Then BumpCar(a,1,f*EnemyWeight(a)):BumpCar(c,3,f*EnemyWeight(c))
					If xx1>xx2 And zz1<zz2 Then BumpCar(a,2,f*EnemyWeight(a)):BumpCar(c,4,f*EnemyWeight(c))
					If xx1<xx2 And zz1<zz2 Then BumpCar(a,3,f*EnemyWeight(a)):BumpCar(c,1,f*EnemyWeight(c))
					If xx1<xx2 And zz1>zz2 Then BumpCar(a,4,f*EnemyWeight(a)):BumpCar(c,2,f*EnemyWeight(c))
					PlaySound BumpSound
					If EnemyBumped(a)=True Then EnemyBumped(c)=True
				EndIf
			EndIf
		Next
		
		;check for collisions with scenery
		CollDist#=0.3
		CarPickPos(1)=LinePick(xx1,yy1+0.15,zz1+0.4,0,0,Colldist)
		CarPickPos(2)=LinePick(xx1+0.2,yy1+0.15,zz1+0.25,Colldist,0,0)
		CarPickPos(3)=LinePick(xx1+0.2,yy1+0.15,zz1+0.25,Colldist,0,0)
		CarPickPos(4)=LinePick(xx1,yy1+0.15,zz1-0.4,0,0,-Colldist)
		CarPickPos(5)=LinePick(xx1-0.2,yy1+0.15,zz1-0.25,-Colldist,0,-0)
		CarPickPos(6)=LinePick(xx1-0.2,yy1+0.15,zz1-0.25,-Colldist,0,0)
		For b=1 To 6
			If CarPickPos(b) Then 
				t=EnemyType(a)
				KillEnemyCar(a,True)
				If EnemyBumped(a)=True Then
					CarsCrashed=CarsCrashed+1
					If t=2 Or t=7 Or t=9 Then AddScoringSprite(1,xx1,yy1,zz1) ;200 pts
					If t=1 Or t=4 Or t=5 Or t=8 Or t=10 Then AddScoringSprite(2,xx1,yy1,zz1) ;300 pts
					If t=3 Or t=6 Then AddScoringSprite(4,xx1,yy1,zz1) ;500 pts
				EndIf
				Goto done
			EndIf
		Next
		.done
	EndIf
	Next		
End Function

Function BumpCar(c,dir,force#)  ;dir=1-4, clockwise from top right
	If c>0 Then
		If dir=1 Then EnemyMX(c)=0.30*force:EnemyMZ(c)=30:EnemySpeed(c)=EnemySpeed(c)+(15*force)
		If dir=2 Then EnemyMX(c)=0.30*force:EnemyMZ(c)=-30:EnemySpeed(c)=EnemySpeed(c)+(15*force)
		If dir=3 Then EnemyMX(c)=-0.30*force:EnemyMZ(c)=-30:EnemySpeed(c)=EnemySpeed(c)+(15*force)
		If dir=4 Then EnemyMX(c)=-0.30*force:EnemyMZ(c)=30:EnemySpeed(c)=EnemySpeed(c)+(15*force)
	EndIf
	
	If c=0 Then
		If dir=1 Then PlayerCarMovX=0.15*force:SpeedMove=10
		If dir=2 Then PlayerCarMovX=0.15*force:SpeedMove=-10
		If dir=3 Then PlayerCarMovX=-0.15*force:SpeedMove=-10
		If dir=4 Then PlayerCarMovX=-0.15*force:SpeedMove=10
	EndIf
End Function

Function AddScore(s)
	Score=Score+s
	If Score>=NextBonusCar Then
		NextBonusCar=NextBonusCar+15000
		PlaySound BonusCarSound
		Lives=Lives+1
	EndIf
End Function